import pystv
from pystv import RaceMetadata, RaceResult
from pystv import RoundResult as RR


def test_results_to_sankey():
    names = ["A", "B", "C", "D", "E", "F"]
    race_result = RaceResult(
        RaceMetadata("race", 2, names),
        [
            RR([0, 2, 5, 3], [2], [], {2: {1: 1}}),
            RR([0, 3, 4, 3], [], [1], {1: {3: 3}}),
            RR([0, 0, 4, 6], [3], [], {}),
        ],
    )
    data = pystv.result_to_sankey_data(race_result)
    assert data.source == [1, 2, 2, 3, 5, 6, 7]
    assert data.target == [5, 5, 6, 7, 11, 10, 11]
    assert data.value == [2, 1, 4, 3, 3, 4, 3]
    assert data.labels == names * 3
    # TODO: node/link tests

    # Make sure this executes (not sure how to test figure generation)
    fig = pystv.create_sankey_fig(data)
    assert fig is not None
